import pgzrun
import random
import sys

TITLE = "ESCAPE ROOM"
WIDTH = 805
HEIGHT = 360
WHITE = (255,255,255)
TEXT_COLOR = (0,0,0)
TEXT_COLOR_2 = (255, 255, 255)
TEXT_SIZE =50
TEXT_SIZE_2 = 30
TEXT_FONT = 'bold'
BLACK = (0, 0, 0)

start_button = Actor("start", pos=(WIDTH//2, HEIGHT//2+60))

# Define clickable areas and prompt text for the office scene
office_clickable_area_1 = Rect(715, 212, 10, 40)
office_clickable_area_2 = Rect(755, 214, 10, 40)
office_clickable_area_3 = Rect(742, 163, 10, 40)
office_clickable_area_4 = Rect(722, 112, 10, 40)

# Define clickable areas and prompt text for the bedroom scene
bedroom_clickable_area_1 = Rect(155, 100, 15, 15)
bedroom_clickable_area_2 = Rect(167, 240, 15, 15)
bedroom_clickable_area_3 = Rect(640, 260, 15, 15)
bedroom_clickable_area_4 = Rect(640, 230, 15, 15)

# Define clickable areas and prompt text for the third room
third_room_clickable_area_a = Rect(58, 165, 15, 15)
third_room_clickable_area_b = Rect(83, 163, 15, 15)
third_room_clickable_area_c = Rect(184, 215, 15, 15)
third_room_clickable_area_d = Rect(184, 215, 15, 15)

# Define room states
MENU = 0
ROOM_OFFICE = 1
ROOM_BEDROOM = 2
ROOM_THIRD = 3
EXIT_SCREEN = 4

current_room = MENU  # Initial room

prompt_text = ""

def draw():
    if current_room == MENU:
        draw_home_screen()
    elif current_room == ROOM_OFFICE:
        screen.blit('office', (0, 0))
    elif current_room == ROOM_BEDROOM:
        screen.blit('bedroom', (0, 0))
    elif current_room == ROOM_THIRD:
        screen.blit('bg', (0, 0))
    elif current_room == EXIT_SCREEN:
        draw_exit_screen()

    screen.draw.text(prompt_text, midbottom=(WIDTH/2, HEIGHT), color="black", fontsize=30)
    
    
def draw_home_screen():
    screen.clear
    screen.fill(WHITE)
    draw_centered_text("ESCAPE ROOM", int(WIDTH//2)-148, 100, TEXT_SIZE, TEXT_COLOR, TEXT_FONT)
    start_button.draw()

def draw_exit_screen():
    screen.clear
    screen.fill(BLACK)
    draw_centered_text("THANKS FOR PLAYING, YOU HAVE ESCAPED THE ESCAPE ROOM", 70, 180, TEXT_SIZE_2, TEXT_COLOR_2, TEXT_FONT)




def draw_centered_text(text,x,y,size,color,font):
    screen.draw.text(text, (x,y), color=color, fontsize=size)

def on_mouse_down(pos, button):
    global prompt_text, current_room
    
    if current_room == 0:
        if start_button.collidepoint(WIDTH//2, HEIGHT//2+100):
            current_room = 1
            print('GAME STARTED')
        

    # Get mouse position
    mouse_pos = pos
    
    if current_room == ROOM_OFFICE:
        check_for_key(office_clickable_area_1, office_clickable_area_2, office_clickable_area_3, office_clickable_area_4, mouse_pos)
    elif current_room == ROOM_BEDROOM:
        check_for_key(bedroom_clickable_area_1, bedroom_clickable_area_2, bedroom_clickable_area_3, bedroom_clickable_area_4, mouse_pos)
    elif current_room == ROOM_THIRD:
        check_for_key(third_room_clickable_area_a, third_room_clickable_area_b, third_room_clickable_area_c, third_room_clickable_area_d, mouse_pos)

def check_for_key(area1, area2, area3, area4, mouse_pos):
    global prompt_text, current_room
    
    if area1.collidepoint(mouse_pos) or area2.collidepoint(mouse_pos) or area3.collidepoint(mouse_pos) or area4.collidepoint(mouse_pos):
        perform_key_check()

def perform_key_check():
    global prompt_text, current_room
    
    if current_room == EXIT_SCREEN:
        # If the key is found in the final room, end the game
        end_game()
    elif random.choice([True, False]):
        prompt_text = "You found a key! Moving to the next room."
        current_room += 1  # Move to the next room
    else:
        prompt_text = "Nothing here. Check another place."

def end_game():
    global prompt_text    
    prompt_text = "Congratulations! You've escaped!"
    
   

pgzrun.go()
